org 0x7c00
bits 16

cli
jmp 0x0:fix_cs
fix_cs:
xor ax, ax
mov ds, ax
mov es, ax
mov fs, ax
mov gs, ax
mov ss, ax
mov sp, 0x7bf0
sti

jmp main

%include 'enable_a20.inc'
%include 'disk.inc'

main:

call enable_a20

mov eax, 1
mov ebx, 0x7e00
mov ecx, 31
call read_sectors

; disable VGA hardware cursor

mov ah, 0x01
mov cx, 0x2607
int 0x10

; enter rm32
cli

lgdt [GDT]
mov eax, cr0
or al, 1
mov cr0, eax

jmp 0x08:.pmode
bits 32
.pmode:
mov ax, 0x10
mov ds, ax
mov es, ax
mov fs, ax
mov gs, ax
mov ss, ax

mov eax, cr0
and al, 0xfe
mov cr0, eax

jmp 0x0:.rm32
.rm32:
xor ax, ax
mov ds, ax
mov es, ax
mov fs, ax
mov gs, ax
mov ss, ax

jmp payload

GDT:

dw .GDTEnd - .GDTStart - 1	; GDT size
dd .GDTStart				; GDT start

.GDTStart:

; Null descriptor (required)

dq 0

; Protected mode

dw 0xFFFF			; Limit
dw 0x0000			; Base (low 16 bits)
db 0x00				; Base (mid 8 bits)
db 10011010b		; Access
db 11001111b		; Granularity
db 0x00				; Base (high 8 bits)

dw 0xFFFF			; Limit
dw 0x0000			; Base (low 16 bits)
db 0x00				; Base (mid 8 bits)
db 10010010b		; Access
db 11001111b		; Granularity
db 0x00				; Base (high 8 bits)

.GDTEnd:


times 510-($-$$) db 0
dw 0xaa55


payload:
incbin 'payload.bin'


times (512*32)-($-$$) db 0
